
<p align="center">
  <img alt="logo" src="https://img11.360buyimg.com/imagetools/jfs/t1/211965/25/7152/22022/61b16785E433119bb/aa41d7a9f7e823f3.png" width="150" style="margin-bottom: 10px;">
</p>

<p align="center">京东风格的轻量级 Vue 组件库，支持移动端 H5 和 小程序开发</p>

<p align="center">
  <a href="https://github.com/jdf2e/nutui/pulls">
    <img src="https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat-square" alt="PRs Welcome">
  </a>
  <a href="https://app.codecov.io/gh/jdf2e/nutui">
    <img src="https://img.shields.io/codecov/c/github/jdf2e/nutui" alt="coverage"/>
  </a>
  <a href="https://github.com/jdf2e/nutui/blob/v4/LICENSE">
    <img src="https://img.shields.io/npm/l/@nutui/nutui.svg" alt="license"/>
  </a>
  <a href="https://www.npmjs.com/package/@nutui/nutui">
    <img src="https://img.shields.io/npm/v/@nutui/nutui.svg?style=flat-square">
  </a>
  <a href="https://www.npmjs.com/package/@nutui/nutui">
    <img src="https://img.shields.io/npm/dt/@nutui/nutui.svg?style=flat-square">
  </a>
</p>
<p align="center">
  <a href="https://github.com/jdf2e/nutui/graphs/contributors">
    <img src="https://img.shields.io/github/contributors/jdf2e/nutui" alt="GitHub contributors">
  </a>
  <a href="https://github.com/jdf2e/nutui/commits">
    <img src="https://img.shields.io/github/commit-activity/m/jdf2e/nutui" alt="GitHub commit activity">
  </a>
  <a href="https://github.com/jdf2e/nutui/issues">
    <img src="https://img.shields.io/github/issues-closed/jdf2e/nutui" alt="GitHub closed issues">
  </a>
  <a href="https://github.com/jdf2e/nutui/commits">
    <img src="https://img.shields.io/github/commits-since/jdf2e/nutui/latest/v4" alt="GitHub commits since latest release (by date)">
  </a>
  <a href="https://github.com/jdf2e/nutui/releases">
    <img src="https://img.shields.io/github/release-date/jdf2e/nutui" alt="GitHub Release Date">
  </a>
  <a href="https://www.jsdelivr.com/package/npm/@nutui/nutui">
    <img src="https://data.jsdelivr.com/v1/package/npm/@nutui/nutui/badge" alt="jsdelivr">
  </a>
</p>

<p align="center">
   <img src="https://img12.360buyimg.com/imagetools/jfs/t1/162421/39/13392/9425/6052ea60E592310a9/264bdff23ef5fe95.png" width="164" alt="NutUI" />
  &nbsp;
   <img src="https://img10.360buyimg.com/imagetools/jfs/t1/211804/23/22232/12144/634e4801Eac435cb6/cfd9e1773cf9423d.png" width="167" title="请用京东APP扫码">
  &nbsp;
  <img src="https://storage.360buyimg.com/jdc-article/gh_f2231eb941be_258.jpg" width="166" title="请用微信扫码">
  &nbsp;
   <img src="https://img12.360buyimg.com/imagetools/jfs/t1/205124/1/15643/30360/62aad730Ea5734bf9/703bb91a0b73282f.png" width="170" title="请用支付宝扫码">
</p>

---

> Nut[nʌt]，源自电影《冰河世纪》里松鼠 Scrat "执迷不悟"，一生追求，即便引发大灾难也绝不松手的坚果。

简体中文 | [English](./README_EN.md)

## 特性

* 🚀 80+ 高质量组件，覆盖移动端主流场景
* 💪 支持一套代码同时开发 H5+多端小程序
* 📖 基于京东APP 10.0 视觉规范
* 🍭 支持按需引用
* 📖 详尽的文档和示例
* 💪 支持 TypeScript
* 💪 支持服务端渲染（测试阶段）
* 🍭 支持组件级别定制主题，内置 700+ 个变量
* 🌍 国际化支持，已支持英文，印尼语和繁体中文
* 🍭 单元测试覆盖率超过 80%，保障稳定性
* 📖 提供 Sketch 设计资源

## 文档

官网：[nutui.jd.com](https://nutui.jd.com)

[@nutui/nutui](https://nutui.jd.com/h5/vue/4x/#/zh-CN/guide/intro)：适用于移动端 H5 页面开发

[@nutui/nutui-taro](https://nutui.jd.com/taro/vue/4x/#/zh-CN/guide/intro)：支持开发 Taro 多端小程序（微信、支付宝、京东等小程序）和 Taro-H5 项目

## 链接

### 官方生态

由 NutUI 官方团队维护的项目如下：

| 项目 | 描述 | 版本 |
| --- | --- | --- |
| [@nutui/nutui](https://github.com/jdf2e/nutui) | NutUI 移动端 H5 版本 | ![nutui](https://img.shields.io/npm/v/@nutui/nutui.svg?label=%20) |
| [@nutui/nutui-taro](https://github.com/jdf2e/nutui) | NutUI Taro 多端版本 | ![nutui](https://img.shields.io/npm/v/@nutui/nutui-taro.svg?label=%20) |
| [@nutui/icons-vue](https://github.com/jdf2e/nutui-icons) | `@nutui/nutui` 使用的图标库 | ![nutui](https://img.shields.io/npm/v/@nutui/icons-vue.svg?label=%20) |
| [@nutui/icons-vue-taro](https://github.com/jdf2e/nutui-icons) | `@nutui/nutui-taro` 使用的图标库 | ![nutui](https://img.shields.io/npm/v/@nutui/icons-vue-taro.svg?label=%20) |
| [@nutui/touch-emulator](packages/nutui-touch-emulator) | 在桌面端使用 NutUI 的辅助库 | ![nutui](https://img.shields.io/npm/v/@nutui/touch-emulator.svg?label=%20) |
| [@nutui/auto-import-resolver](packages/nutui-auto-import-resolver) | `unplugin-auto-import` 插件的 reolver 配置 | ![nutui](https://img.shields.io/npm/v/@nutui/auto-import-resolver.svg?label=%20) |
| [@nutui/playground](packages/nutui-playground) | NutUI 在线 Playground | - |
| [nutui-demo](https://github.com/jdf2e/nutui-demo) | NutUI 官方示例合集 | - |

### 社区生态

由社区维护的项目如下，欢迎补充：

| 项目 | 描述 |
| --- | --- |
| [nutui-uniapp](https://github.com/nutui-uniapp/nutui-uniapp) | 基于 NutUI 4.x 版本开发的 uni-app 组件库 |
| [jwaterwater/uni-nutui](https://github.com/jwaterwater/uni-nutui) | 基于 NutUI 3.x 版本开发的 uni-app 组件库 |
| [common-intellisense](https://github.com/Simon-He95/common-intellisense) | 提供 NutUI 4.x 版本智能提示的 vscode 插件 |

## 项目状态

![Alt](https://repobeats.axiom.co/api/embed/fd45cb2c6840153af6328b050e87ce01d785b72b.svg "Repobeats analytics image")

## 使用案例

NutUI 已经投入了我们的生产环境中使用，业界也在广泛地使用 NutUI 开发多端应用。
<p>
<img src="https://raw.githubusercontent.com/jdf2e/nutui-user-cases/master/user-cases.jpg" alt="NutUI" />
</p>
<p><a href="https://nutui.jd.com/#/case">更多案例</a></p>

## 开发交流

| 微信群 |内部咚咚群 |
| --- |--- |
| <img src="https://storage.360buyimg.com/nutui-static/image/wx-code.png" width="100" /> 添加好友并回复「NutUI Vue」 | 82957939

## 参与共建

### NutUI 社区共建倡议

[NutUI 邀您共建，Contributor 您好](https://github.com/jdf2e/nutui/issues/1789)

### 为 NutUI 贡献代码

NutUI 的共建方向主要分为：解决 issue、修复 bug、新增组件、增加国际化、UI 定制、平台适配、跨端扩展等。

欢迎社区开发者参与共建，在贡献您的代码之前请先阅读 [《NutUI 贡献指南》](https://github.com/jdf2e/nutui/issues/1671)。

## 问题反馈与建议

[给 NutUI 提 Issue](https://nutui.jd.com/nutui-issue-helper/?repo=jdf2e/nutui&lang=zh-cn)

> 在反馈问题之前，推荐阅读 [《提问的智慧》](https://github.com/ryanhanwu/How-To-Ask-Questions-The-Smart-Way)、[《如何向开源社区提问题》](https://github.com/seajs/seajs/issues/545)和[《如何有效地报告 Bug》](http://www.chiark.greenend.org.uk/%7Esgtatham/bugs-cn.html)，这样您能够更容易获得理解和帮助。

[参与 NutUI 社区讨论](https://github.com/jdf2e/nutui/discussions)

如果您有任何想法、疑问或建议，都可以参与社区讨论分享您的观点。

## 贡献者们

感谢以下所有给 NutUI 贡献过代码的 [开发者](https://github.com/jdf2e/nutui/graphs/contributors)。

<a href="https://github.com/jdf2e/nutui/graphs/contributors">
  <img src="https://opencollective.com/nutui/contributors.svg?width=890&button=false" alt="contributors">
</a>

## 更新日志

查阅 [Release](https://github.com/jdf2e/nutui/releases)。

## License

[MIT](https://github.com/jdf2e/nutui/blob/v4/LICENSE)

## GitHub Stargazaers

![stargazers](https://starchart.cc/jdf2e/nutui.svg)
